100 rem $$asmb=win1_uti_spr_asm_asm_spr2asm_bin,0,10
102 rem $$stak=16384
104 rem $$heap=4096
106 :
108 ext_proc 'DERLE'
110 ext_fn   'ENRLE', 'LDATA', 'GET_SSPR'
112 ext_fn   'EVEN', 'ODD', 'VALID%', 'LDIV', 'LMOD'
114 ext_fn   'DETAB$', 'EXTRACT$', 'ERRM$'
116 :
118 rem + ************************************************************************ +
120 rem *<                                Spr2Asm                                 >*
122 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
124 rem *       Disassemble (complex) sprite or chain of sprites of any mode       *
126 rem *                                                                          *
128 rem *        /F - or /I - Input file name (or only file name on command line)  *
130 rem *        /A - Address of sprite. If /A given /F and /I ignored             *
132 rem *        /O - Output file name (optional)                                  *
134 rem *        /S - Stack size (number of elements) (Optional, default 20)       *
136 rem *        /R - Output suitable for _rel file   (Default is single, type 0)  *
138 rem *        /G - Output suitable for GWASS       (Default is Qmac)            *
140 rem *                                                                          *
142 rem *            Read the spr2asm_txt file for further information!            *
144 rem + ------------------------------------------------------------------------ +
146 rem * V0.02, pjw, 2024 Sep 29                                                  *
148 rem * V0.03, pjw, 2024 Oct 05, Address option                                  *
150 rem + ************************************************************************ +
152 :
154 quote$  = '"' & "'"
156 ert GetCmd(CMD$)
158 :
160 rem     If address not given then load sprite
162 if spa = 0 then
164  spa = LDATA(fni$): ert spa
166 else
168  fni$ = '$' & hex$(spa, 32)
170 endif
172 :
174 co = fop_over(fno$)
176 if co < 0: rechp spa: ert co
178 :
180 rem     Init variables
182 tab$ = chr$(9): tab2$ = tab$ & tab$
184 dcl$ = tab$ & 'dc.l ' & tab$
186 dcw$ = tab$ & 'dc.w ' & tab$
188 dcb$ = tab$ & 'dc.b ' & tab$
190 :
192 rem     Sprite block options
194 dim block$(4, 18)
196 restore: for i% = 0 to 4: read block$(i%)
198 data 'available', 'available, current', 'selected', 'selected, current', 'unavailable'
200 :
202 rem     GLOBal structures (stacks)
204 rem stkz% = Max number of each structure
206 dim spr(stkz%), sprd(stkz%), spr$(stkz%, 8): spr% = -1
208 dim pat(stkz%), patd(stkz%), pat$(stkz%, 8): pat% = -1
210 dim msk(stkz%), mskd(stkz%), msk$(stkz%, 8): msk% = -1
212 dim blk(stkz%), blkd(stkz%), blk$(stkz%, 8): blk% = -1
214 dim opt(stkz%), optd(stkz%), opt$(stkz%, 8): opt% = -1
216 :
218 rem     Produce assembler header
220 bput#co; 59, ' Disassembly of ', fni$, 44, 32, date$, 10, 10
222 :
224 if gwas then
226  if relo then
228   bput#co; tab$, 'section sprite', 10, 10
230  endif
232 else
234  bput#co; tab$, 'section sprite', 10, 10
236 endif
238 :
240 if not relo then
242  bput#co; tab$, 'filetype 0', 10, 10
244  bput#co; 59:                   rem Cancel xdef
246 endif
248 bput#co; tab$, 'xdef', tab$,
250 bput#co; 'sp' & peek(spa) & hex$(peek(spa + 1), 8), 48, 10, 10
252 :
254 rem     Now do it!
256 progerr = 0:                    rem No errors yet!
258 spr2asm#co; spa
260 :
262 rem     Finish off
264 bput#co; 42, 10, tab$, 'end', 10
266 close#co
268 beep 2000, 2:                   rem Done!
270 quit progerr
272 :
274 :
276 rem + ------------------------------------------------------------------------ +
278 rem |<                                spr2asm                                 >|
280 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
282 rem |                 Disassemble a sprite or chain of sprites                 |
284 rem |                                                                          |
286 rem | Parameters:                                                              |
288 rem |         ch  = open channel to a suitably headed assembler file           |
290 rem |         adr = address of source sprite loaded into memory                |
292 rem + ------------------------------------------------------------------------ +
294 rem | V0.01, pjw, 2024 Sep 16                                                  |
296 rem + ------------------------------------------------------------------------ +
298 :
300 def proc spr2asm(ch, adr)
302 DisSprs#ch; adr
304 DoOpts
306 enddef spr2asm
308 :
310 :
312 rem + ------------------------------------------------------------------------ +
314 rem |<                                DisSprs                                 >|
316 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
318 rem |                           Disassmble a sprite                            |
320 rem |                                                                          |
322 rem | Converts binary sprite data to assembler statements ready to reassemble  |
324 rem | Disassembles sprites of any mode and structure, provided correctly       |
326 rem | defined.                                                                 |
328 rem + ------------------------------------------------------------------------ +
330 rem | V0.01, pjw, 2024 Sep 16                                                  |
332 rem | V0.02, pjw, 2024 Sep 20, Better end of chain detection                   |
334 rem + ------------------------------------------------------------------------ +
336 :
338 def proc DisSprs(ch, adr)
340 loc p, ct%, pt, ms, nx, op, sb
342 loc sm, cm, t%
344 loc ofs, onx, f%: rem txt$ is scratch
346 :
348 rem     Sprite header
350 f% = Push%(adr, 'sp' & peek(adr) & hex$(peek(adr + 1), 8), spr, sprd, spr$, spr%)
352 if sprd(f%): return :           rem Already defined and processed
354 sprd(f%) = 1:                   rem Wasnt done but is now
356 :
358 rem     Get some info
360 sm  = peek(adr):                rem Sprite mode
362 :
364 rem     Check for system sprite
366 if sm = 0 then
368  nx = GET_SSPR(peek(adr + 1)):  rem Borrow nx for this
370  if nx >= 0 then
372   DisSprs#ch; nx: return
374  else
376   OutErr nx, 'System sprite error'
378   return :                      rem We cant handle this..
380  endif
382 endif
384 :
386 cm  = peek(adr + 1):            rem Colour mode
388 ct% = peek(adr + 3):            rem Control byte
390 :
392 rem     Output header
394 bput#ch; spr$(f%), 10:          rem Output sprite label
396 sel on sm
398  = 0: txt$ = 'System sprite number ' & cm
400  = 1: if cm = 0: t% = 0: else: t% = 8
402       txt$ = 'QL mode ' & t% & ' sprite'
404  = 2: txt$ = 'GD2 mode ' & cm & ' sprite'
406 endsel
408 :
410 bput#ch; dcb$, 36, hex$(sm, 8), 44, 36, hex$(cm, 8), tab2$, txt$, 10
412 t% = peek(adr + 2)
414 sel on t%
416  = 0: txt$ = 'cached'
418  = 3: txt$ = 'not cached'
420  = remainder: txt$ = 'dynamic sprite time'
422 endsel
424 :
426 bput#ch; dcb$, '' & t%, tab2$, txt$, 10
428 bput#ch; dcb$, 37, bin$(ct%, 8), tab$, MkCtr$, ' Control byte', 10
430 bput#ch; dcw$
432 rem For some reason Qlib misses on this contruct!!
434 rem for p = adr + 4 to adr + 8 step 2: bput#ch; '' & peek_w(p), 44
436 rem    bput#ch; '' & peek_w(adr + 10), tab$, 'size and origen', 10
438 bput#ch; '' & peek_w(adr +  4), 44
440 bput#ch; '' & peek_w(adr +  6), 44
442 bput#ch; '' & peek_w(adr +  8), 44
444 bput#ch; '' & peek_w(adr + 10), tab$, 'size and origen', 10
446 :
448 rem     Sprite pointers
450 pt = peek_l(adr + $0C): bput#ch; dcl$
452 if pt then
454  pt = adr + pt + $0C
456  f% = Push%(pt, 'pt', pat, patd, pat$, pat%)
458  bput#ch; pat$(f%), '-*', tab2$, '-> pattern', 10
460 else
462  bput#ch; 48, tab$, 'no pattern (= blob)', 10
464 endif
466 :
468 ms = peek_l(adr + $10): bput#ch; dcl$
470 if ms then
472  ms = adr + ms + $10
474  f% = Push%(ms, 'ms', msk, mskd, msk$, msk%)
476  bput#ch; msk$(f%), '-*', tab2$, '-> mask', 10
478 else
480  bput#ch; 48, tab2$, 'no mask', 10
482 endif
484 :
486 nx  = peek_l(adr + $14): bput#ch; dcl$
488 if nx then
490  nx = adr + nx + $14
492  rem Weed out various end of chain schemes!
494  if peek_l(nx) = 0 or peek_l(nx) = -1 or peek_w(nx + 2) = 65535 then
496   nx = 0: bput#ch; 48, tab2$, 'no next object', 10: rem Correct termination value
498  else
500   f% = Push%(nx, 'sp' & peek(nx) & hex$(peek(nx + 1), 8), spr, sprd, spr$, spr%)
502   bput#ch; spr$(f%), '-*', tab$, '-> next object', 10
504  endif
506 else
508  bput#ch; 48, tab2$, 'no next object', 10
510 endif
512 :
514 rem     More sprite pointers
516 op = 0
518 if BTST%(4) then
520  rem Options block
522  op = peek_l(adr + $18): bput#ch; dcl$
524  if op then
526   op = adr + op + $18
528   f% = Push%(op, 'op', opt, optd, opt$, opt%)
530   bput#ch; opt$(f%), '-*', tab2$, '-> options', 10
532  else
534   bput#ch; 48, tab2$, 'no options', 10
536  endif
538 endif
540 :
542 if BTST%(2) then
544  rem Sprite block
546  if op = 0 then
548   bput#ch; dcl$, 48, tab2$, 'no options', 10: rem If SP set, so must OB be
550  endif
552  sb = peek_l(adr + $1C): bput#ch; dcl$
554  if sb then
556   sb = adr + sb + $1C
558   f% = Push%(sb, 'sb', blk, blkd, blk$, blk%)
560   bput#ch; blk$(f%), '-*', tab2$, '-> sprite block', 10
562  else
564   bput#ch; 48, tab2$, 'no sprite block', 10
566  endif
568 else
570  if BTST%(4) then
572   rem Doesnt have to be there, but we'll put it in anyway
574   bput#ch; dcl$, 48, tab2$, 'no sprite block', 10
576  endif
578 endif
580 bput#ch; 10
582 :
584 rem     Pattern
586 if pt then
588  f% = Push%(pt, 'pt', pat, patd, pat$, pat%)
590  if patd(f%) = 0 then
592   patd(f%) = 1:                         rem Done define pattern
594   bput#ch; pat$(f%), 10
596   if BTST%(6) then
598    OutRLE pt:                           rem Output compressed pattern
600   else
602    OutData pt:                          rem Output uncompressed pattern
604   endif
606  endif
608 endif
610 :
612 rem      Mask/Alpha
614 if ms then
616  f% = Push%(ms, 'ms', msk, mskd, msk$, msk%)
618  if mskd(f%) = 0 then
620   mskd(f%) = 1:                         rem Done define mask
622   bput#ch; msk$(f%)
624   OutMask ms:                           rem Output any type of mask
626  endif
628 endif
630 :
632 rem     Sprite block
634 if sb then
636  f% = Push%(sb, 'sb', blk, blkd, blk$, blk%)
638  if blkd(f%) = 0 then
640   blkd(f%) = 1:                         rem Done define sprite block
642   bput#ch; blk$(f%), 10
644   :
646   for onx = 0 to 16 step 4
648    ofs = peek_l(sb + onx):              rem For each of 5 elements..
650    if ofs then
652     ofs = ofs + sb + onx:               rem .. with non-zero pointer..
654     f% = Push%(ofs, 'sp' & peek(ofs) & hex$(peek(ofs + 1), 8), spr, sprd, spr$, spr%)
656     bput#ch; dcl$, spr$(f%), '-*', tab$, '-> ', block$(onx div 4), 10
658    else
660     bput#ch; dcl$, 48, tab2$, ' | ', block$(onx div 4), 10
662    endif
664   endfor onx
666   bput#ch; 10
668  endif
670  :
672  rem     Output each sprite referenced in block..
674  for onx = 0 to 16 step 4
676   ofs = peek_l(sb + onx)
678   if ofs then
680    ofs = ofs + sb + onx
682    f% = Push%(ofs, 'sp' & peek(ofs) & hex$(peek(ofs + 1), 8), spr, sprd, spr$, spr%)
684    if sprd(f%) = 0: DisSprs#ch; ofs:    rem .. recursively..
686   endif
688  endfor onx
690 endif
692 :
694 if nx: DisSprs#ch; nx:                  rem Next sprite, recursively
696 enddef DisSprs
698 :
700 :
702 rem + ------------------------------------------------------------------------ +
704 rem |<                                 DoOpts                                 >|
706 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
708 rem |                   Does the Options as a separate thing                   |
710 rem |                                                                          |
712 rem | Ideally, recognised options, like "TEXT", should be output as defined    |
714 rem | This may come later..                                                    |
716 rem + ------------------------------------------------------------------------ +
718 rem | V0.01, pjw, 2024 Sep 02                                                  |
720 rem + ------------------------------------------------------------------------ +
722 :
724 def proc DoOpts
726 loc op%, op, nx, ad, c%, lb$(10)
728 loc chain
730 c% = 0
732 for op% = 0 to opt%
734  op = opt(op%)
736  bput#ch; opt$(op%), 10
738  nx = peek_l(op)
740  if nx = 0 then
742   OutErr 0, 'Outputting Options: No next at $' & hex$(op - adr, 32)
744   ret
746  endif
748  nx = nx + op:                                  rem Size of option -> next
750  rep chain
752   c% = c% + 1: lb$ = '_' & c%:                  rem Name of next label
754   bput#ch; dcl$, opt$(op%) & lb$ & '-*', 10:    rem Next option in this chain
756   bput#ch; dcb$, 39, peek$(op + 4, 4), 39, 10:  rem Option name
758   :
760   for ad = op + 8 to nx - 4 step 4
762    bput#ch; dcl$, 36, hex$(peek_l(ad), 32), 10
764   endfor ad
766   bput#ch; 10
768   :
770   if peek_l(nx) = 0 then
772    bput#ch; opt$(op%) & lb$, tab2$, tab2$, 59, 'end options ' & op%, 10
774    bput#ch; dcl$, 48, 10
776    c% = 1: exit chain:                          rem Done with this chain of options
778   endif
780   :
782   bput#ch; opt$(op%) & lb$, 10
784   op = nx: nx = peek_l(op)
786   if nx = 0 then
788    OutErr 0, 'Outputting Options: No next at $' & hex$(op - adr, 32)
790    ret
792   endif
794   nx = nx + op
796  endrep chain
798 endfor op%
800 enddef DoOpts
802 :
804 :
806 rem + ************************************************************************ +
808 rem *<                              Stack stuff                               >*
810 rem + ************************************************************************ +
812 :
814 rem + ------------------------------------------------------------------------ +
816 rem |<                                Push%                                   >|
818 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
820 rem | Tailored routine to order sprite structures and connecting addresses     |
822 rem | to labels.                                                               |
824 rem |                                                                          |
826 rem | Push address and label onto a given stack provided it is unique. The     |
828 rem | record is ordered according to address, which acts as the index.         |
830 rem |                                                                          |
832 rem | Returns the index of the current item. Updates cnt% if item was new.     |
834 rem |                                                                          |
836 rem | Parameters are:                                                          |
838 rem |        ad   is the address of structure                                  |
840 rem |        lb$  is the label stem given                                      |
842 rem |        stk  is the address stack (array)                                 |
844 rem |        ref  is the stack status - done/not done (array)                  |
846 rem |        stk$ is the label stack (array)                                   |
848 rem |        cnt% is the current size of the stack                             |
850 rem + ------------------------------------------------------------------------ +
852 rem | V0.01, pjw, 2024 Aug 15                                                  |
854 rem | V0.02, pjw, 2024 Aug 24                                                  |
856 rem + ------------------------------------------------------------------------ +
858 :
860 def fn Push%(ad, lb$, stk, ref, stk$, cnt%)
862 loc n%
864 SELect ON cnt%
866  = -1: cnt% = 0: stk(cnt%) = ad: ref(0) = 0: stk$(cnt%) = lb$ & cnt%: n% = cnt%
868  =  0: if ad <> stk(cnt%) then
870         cnt% = 1
872         IF ad < stk(0) then
874          n% = 0
876          stk(cnt%) = stk(n%): ref(cnt%) = ref(n%): stk$(cnt%) = stk$(n%)
878          stk(n%) = ad: ref(n%) = 0: stk$(n%) = lb$ & cnt%
880         else
882          n% = cnt%
884          stk(cnt%) = ad: ref(cnt%) = 0: stk$(cnt%) = lb$ & cnt%
886         endif
888        else
890         n% = cnt%
892        endif
894  = dimn(stk): OutErr -5, 'Increase stack size! ' & lb$ & ' >= ' & cnt%
896               quit -5: rem Fatal
898  = REMAINDER
900    n% = BSearch%(ad, stk(0 TO cnt%))
902    IF n% < 0 then
904     n% = ABS(n% + 1)
906     Insert ad, ref(n%), lb$ & (cnt% + 1), stk, ref, stk$, n%
908    END IF
910 END SELect
912 ret n%
914 END def Push%
916 :
918 :
920 rem + ======================================================================== +
922 rem *<                                UniqueN                                 >*
924 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
926 rem *     Scan a list using binary search routine and return +ve if found.     *
928 rem * If not found, return -1 - ve, and add item to list, creating a list of   *
930 rem * unique items ordered by the size of the indexing variable.               *
932 rem *                                                                          *
934 rem * This version without sentinel. That means it has to work around          *
936 rem * S*BASIC's treatment of a single element array being treated as a         *
938 rem * scalar variable. Index starts at 0.                                      *
940 rem *                                                                          *
942 rem * This version is modified to use two variables, an index and a label.     *
944 rem * The index must be a number. The index and label are stored in separate   *
946 rem * arrays but are treated as one unit.                                      *
948 rem *                                                                          *
950 rem * Note: GLOBal cnt%                                                        *
952 rem + ------------------------------------------------------------------------ +
954 rem * V0.01, pjw, 2020 Dec 27                                                  *
956 rem * V0.02, pjw, 2021 Jun 30, No sentinel                                     *
958 rem * V0.03, pjw, 2021 Jul 03, Updated sub routines                            *
960 rem * V0.03, pjw, 2021 Jul 12, Numeric and case-dependent strings; same algo   *
962 rem * V0.03, pjw, 2024 Aug 15, This version modified to act as stack for       *
964 rem *                          spr2asm, using multiple stacks                  *
966 rem + ======================================================================== +
968 :
970 :
972 rem + ------------------------------------------------------------------------ +
974 rem |<                                BSearch                                 >|
976 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
978 rem |                              Binary Search                               |
980 rem |                                                                          |
982 rem | Returns position if found, or -1 - position where item should go. Thus   |
984 rem | it can be used to add new, unique items to a list, in alphabetical order |
986 rem |                                                                          |
988 rem | Designed for numeric data but can be used for CASE-dependent strings     |
990 rem + ------------------------------------------------------------------------ +
992 rem | V0.01, pjw, 1996+, From TAOCP 6.2.1                                      |
994 rem | V0.02, pjw, 2021 Jun 30, Single comp and then SELect. Looks neater..     |
996 rem | V0.03, pjw, 2021 Jul 03, Not found returns -1-pos: arrays can start at 0 |
998 rem | V0.03, pjw, 2022 Jul 12, Numeric and CASE-dependent strings only         |
1000 rem + ------------------------------------------------------------------------ +
1002 :
1004 DEFine FuNction BSearch%(item, Arr)
1006 LOCal loop, u%, l%, i%
1008 l% = 0: u% = DIMN(Arr)
1010 REPeat loop
1012  IF u% < l%: i% = -1 - l%: EXIT loop:           rem Not found here
1014  i% = INT((l% + u%) / 2)
1016  IF item = Arr(i%): EXIT loop
1018  IF item < Arr(i%) THEN
1020   u% = i% - 1
1022  ELSE
1024   l% = i% + 1
1026  END IF
1028 END REPeat loop
1030 RETurn i%
1032 END DEFine BSearch%
1034 :
1036 :
1038 rem + ------------------------------------------------------------------------ +
1040 rem |<                                 Insert                                 >|
1042 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
1044 rem |            Insert item in an array at given position, 0..DIMN            |
1046 rem |                                                                          |
1048 rem | Item and array can be of any type                                        |
1050 rem |                                                                          |
1052 rem | GLOBal cnt%                                                              |
1054 rem + ------------------------------------------------------------------------ +
1056 rem | V0.01, pjw, 2017 Mar                                                     |
1058 rem | V0.02, pjw, 2021 Jun 30, Simplified                                      |
1060 rem | V0.02, pjw, 2024 Aug 15, Modified to take two variables, index and label |
1062 rem + ------------------------------------------------------------------------ +
1064 :
1066 DEFine PROCedure Insert(item, rf, item$, Arr, Arf, Arr$, at%)
1068 LOCal i%
1070 cnt% = cnt% + 1
1072 IF at% < cnt% THEN
1074  FOR i% = cnt% TO at% + 1 STEP -1
1076   Arr(i%)   = Arr(i% - 1)
1078   Arf(i%)   = Arf(i% - 1)
1080   Arr$(i%)  = Arr$(i% - 1)
1082  END FOR i%
1084 END IF
1086 Arr(at%)   = item
1088 Arf(at%)   = rf
1090 Arr$(at%)  = item$
1092 END DEFine Insert
1094 :
1096 :
1098 rem + ************************************************************************ +
1100 rem *<                              Data output                               >*
1102 rem + ************************************************************************ +
1104 :
1106 rem + ------------------------------------------------------------------------ +
1108 rem |<                                OutMask                                 >|
1110 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
1112 rem |           Output colour mask data with all the various options           |
1114 rem |                                                                          |
1116 rem | Subroutine: uses caller's LOCals                                         |
1118 rem |                                                                          |
1120 rem | Dependencies: OutRLE, OutData; Bin2Asm                                   |
1122 rem + ------------------------------------------------------------------------ +
1124 rem | V0.01, pjw, 2024 Sep 01                                                  |
1126 rem + ------------------------------------------------------------------------ +
1128 :
1130 def proc OutMask(mad)
1132 loc x, c
1134 if BTST%(5) then
1136  rem Flag alpha
1138  bput#ch; tab2$, tab2$, 59, 'alpha', 10
1140 else
1142  bput#ch; 10
1144 endif
1146 :
1148 if BTST%(7) then
1150  rem Compressed mask (alpha or not)
1152  OutRLE mad
1154 else
1156  rem Uncompressed mask
1158  if BTST%(5) then
1160   rem Alpha
1162   x = peek_w(adr + 4)
1164   if x > 16: c = 16: else: c = x
1166   rem Output alpha as bytes, no padding (except last if odd)
1168   Bin2Asm mad, x * peek_w(adr + 6),  c, 1
1170  else
1172   rem Plain mask data
1174   OutData mad
1176  endif
1178 endif
1180 enddef OutMask
1182 :
1184 :
1186 rem + ------------------------------------------------------------------------ +
1188 rem |<                                 OutRLE                                 >|
1190 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
1192 rem |                 Output RLE data as assembler statements                  |
1194 rem |                                                                          |
1196 rem | As there is no assured way of knowing how large the compressed data      |
1198 rem | block is, it first needs to be decompressed and then recompressed        |
1200 rem | again.                                                                   |
1202 rem |                                                                          |
1204 rem |        dad = compressed Data base ADress                                 |
1206 rem |                                                                          |
1208 rem | LOCal variables:                                                         |
1210 rem |        buf = reserved buffer address                                     |
1212 rem |        csz = recompressed data size                                      |
1214 rem |        bsz = buffer half size: top for uncomp, bottom for recomp         |
1216 rem |        bad = recompressed buffer address                                 |
1218 rem |        esz = element size 1, 2, 4                                        |
1220 rem |                                                                          |
1222 rem | GLOBal #ch                                                               |
1224 rem | Dependencies: DERLE, ENRLE; Bin2Asm                                      |
1226 rem + ------------------------------------------------------------------------ +
1228 rem | V0.01, pjw, 2024 Aug 20                                                  |
1230 rem + ------------------------------------------------------------------------ +
1232 :
1234 def proc OutRLE(dad)
1236 loc buf, csz, bsz, bad, esz
1238 esz = chr$(peek(dad + 3)):                      rem The x in RLEx
1240 bsz = peek_l(dad + 4):                          rem RLEx flag
1242 buf = alchp(bsz + bsz + 2):                     rem Double buffer size
1244 bad = buf + EVEN(bsz):                          rem Compressed data goes here
1246 DERLE dad + 8, buf, bsz, esz:                   rem Uncompress data, skipping header
1248 csz = ENRLE(buf, bad, bsz, esz):                rem Recompress to get correct data size
1250 if csz < 0: OutErr csz, 'OutRLE: Compression error': quit csz: rem Fatal
1252 :
1254 bput#ch; dcb$, 39, peek$(dad, 4), 39, 10
1256 print#ch; dcl$; bsz\
1258 :
1260 sel on esz
1262  = 1: Bin2Asm bad, csz, 16, esz
1264  = 2: Bin2Asm bad, csz,  8, esz
1266  = 4: Bin2Asm bad, csz,  4, esz
1268 endsel
1270 BPUT#ch; 10
1272 rechp buf
1274 enddef OutRLE
1276 :
1278 :
1280 rem + ------------------------------------------------------------------------ +
1282 rem |<                                OutData                                 >|
1284 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
1286 rem |                Output binary data as assembler statements                |
1288 rem |                                                                          |
1290 rem | Subroutine of DisSprs, so has access to all its LOCals:                  |
1292 rem |                                                                          |
1294 rem |        adr = current sprite's address                                    |
1296 rem |        sm  = current sprite's mode                                       |
1298 rem |        cm  = current sprite's colour mode                                |
1300 rem |                                                                          |
1302 rem | Parameter bad => address of current data block to output                 |
1304 rem | GLOBal dcb$, tab$                                                        |
1306 rem + ------------------------------------------------------------------------ +
1308 rem | V0.01, pjw, 2020                                                         |
1310 rem | V0.01, pjw, 2024 Aug 29, tweaked for spr2asm                             |
1312 rem | V0.02, pjw, 2024 Sep 27, thanks to BSJ for QL mode formula!              |
1314 rem + ------------------------------------------------------------------------ +
1316 :
1318 def proc OutData(bad)
1320 loc bsz, x, y, c
1322 rem     Work out data size
1324 x = peek_w(adr + 4): y = peek_w(adr + 6)
1326 if x > 16: c = 16: else: c = x
1328 sel on sm
1330  = 0: rem Cant handle this here..
1332       bput#ch; tab2$, tab2$, 59, ' ### sm = ' & sm & ', cm = ' & cm, 10
1334       er = -19
1336  = 1: rem QL mode 0/8 data
1338         Bin2Asm bad, y * 4 * int((x + 15) / 16), c, 2: rem BSJ
1340  = 2: rem GD2 data, multiples of 4b
1342  sel on cm
1344   =  0: rem  1 bit black&white
1346         Bin2Asm bad, y * 4 * ((x + 31) DIV 32), (c + 1) div 2, 2
1348   =  3: rem  1 bit palette mapped
1350         Bin2Asm bad, y * 4 * ((x + 31) DIV 32), (c + 1) div 2, 2
1352   =  4: rem  2 bit fixed gr palette
1354         Bin2Asm bad, y * 4 * ((x + 15) DIV 16), (c + 1) div 2, 2
1356   =  7: rem  2 bit palette mapped
1358         Bin2Asm bad, y * 4 * ((x + 15) DIV 16), (c + 1) div 2, 2
1360   =  8: rem  4 bit fixed irgb palette
1362         Bin2Asm bad, y * 4 * ((x + 7) DIV 8), c, 1
1364   = 15: rem  4 bit palette mapped
1366         Bin2Asm bad, y * 4 * ((x + 7) DIV 8), c, 1
1368   = 16: rem  8 bit fixed palette (equals Aurora palette) == native
1370         Bin2Asm bad, y * 4 * ((x + 3) DIV 4), c, 1
1372   = 31: rem  8 bit palette mapped
1374         Bin2Asm bad, y * 4 * ((x + 3) DIV 4), c, 1
1376   = 32: rem 16 bit QPC/QXL %gggbbbbbrrrrrggg format     == native
1378         Bin2Asm bad, y * 4 * ((x + 1) DIV 2), (c + 1) div 2, 2
1380   = 33: rem 16 bit Q40 %gggggrrrrrbbbbbw format         == native
1382         Bin2Asm bad, y * 4 * ((x + 1) DIV 2), (c + 1) div 2, 2
1384   = 64: rem 32 bit $RRGGBB00 format
1386         Bin2Asm bad, y * 4 * x, (c + 3) DIV 4, 4
1388   = remainder: er = -19
1390  endsel
1392 endsel
1394 bput#ch; 10
1396 if er < 0: OutErr er, 'Outputting data at address $' & hex$(bad - adr, 32)
1398 enddef OutData
1400 :
1402 :
1404 def proc OutErr(ec, txt$)
1406 if len(txt$) then
1408  bput#ch; 10, '*** Error ', txt$, ' ***', 10
1410 endif
1412 if ec < 0 then
1414  bput#ch; 10, '*** Error ', ERRM$(ec), ' ***', 10
1416 endif
1418 if ec < 0: progerr = ec: else: progerr = -1
1420 enddef OutErr
1422 :
1424 :
1426 rem + ------------------------------------------------------------------------ +
1428 rem |<                                Bin2Asm                                 >|
1430 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
1432 rem |                Output binary data as assembler statements                |
1434 rem |                                                                          |
1436 rem | Note: This version rounds the buffer up to nearest whole element size!   |
1438 rem | Note: If odd number of bytes an alignment ds.w 0 is appended.            |
1440 rem | Uses long DIV/MOD, so SBASIC only in this form (Use my LDIV/LMOD for QL  |
1442 rem | and compiled).                                                           |
1444 rem |                                                                          |
1446 rem |         buf = buffer address                                             |
1448 rem |         bsz = size of data                                               |
1450 rem |         col = number of columns                                          |
1452 rem |         wrd = word size, 1, 2 or 4                                       |
1454 rem |                                                                          |
1456 rem | GLOBally defined: #ch; tab$, dcb$, dcw$, dcl$                            |
1458 rem + ------------------------------------------------------------------------ +
1460 rem | V0.01, pjw, 2024 Sep 01                                                  |
1462 rem | V0.02, pjw, 2024 Sep 03, abreviated; LDIV, LMOD for Qlib                 |
1464 rem | V0.03, pjw, 2024 Sep 28, from function to procedure                      |
1466 rem + ------------------------------------------------------------------------ +
1468 :
1470 def proc Bin2Asm(buf, bsz, col, wrd)
1472 loc r, c, ad, hx, ne, row, dc$(6)
1474 ad  = buf:                                      rem Address running pointer
1476 ne  = int((bsz + wrd - 1) / wrd):               rem Number of whole elements
1478 row = LDIV(ne, col):                            rem Number of whole rows
1480 hx  = wrd * 8:                                  rem Word size as hex parameter
1482 sel on wrd
1484  = 1: dc$ = dcb$
1486  = 2: dc$ = dcw$
1488  = 4: dc$ = dcl$
1490 endsel
1492 :
1494 rem     Complete rows
1496 FOR r = 0 TO row - 1
1498  B2A col
1500  ad = ad + wrd
1502 END FOR r
1504 :
1506 rem     Remainder (if any)
1508 if row then
1510  row = LMOD(ne, col):                              rem Actually col..
1512  if row: B2A row
1514 else
1516  B2A ne
1518 endif
1520 if wrd = 1 and LMOD(bsz, 2): bput#ch; tab$, 'ds.w 0', 10
1522 enddef Bin2Asm
1524 :
1526 def proc B2A(n)
1528 bput#ch; dc$
1530 FOR c = 0 TO n - 2
1532  sel on wrd
1534   = 1: bput#ch; 36; HEX$(peek  (ad), hx), 44
1536   = 2: bput#ch; 36; HEX$(peek_w(ad), hx), 44
1538   = 4: bput#ch; 36; HEX$(peek_l(ad), hx), 44
1540  endsel
1542  ad = ad + wrd
1544 endfor c
1546 rem End for row
1548 sel on wrd
1550  = 1: bput#ch; 36; HEX$(peek  (ad), hx), 10
1552  = 2: bput#ch; 36; HEX$(peek_w(ad), hx), 10
1554  = 4: bput#ch; 36; HEX$(peek_l(ad), hx), 10
1556 endsel
1558 enddef B2A
1560 :
1562 :
1564 rem + ************************************************************************ +
1566 rem *<                             General Utils                              >*
1568 rem + ************************************************************************ +
1570 :
1572 :
1574 rem + ------------------------------------------------------------------------ +
1576 rem |<                                 BTST%                                  >|
1578 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
1580 rem |                        Test Bit and return result                        |
1582 rem |                                                                          |
1584 rem | btn% = Bit number (0 to 15)                                              |
1586 rem | flg% = Flag: Byte or word to test                                        |
1588 rem |        (In the case of spr2asm it will always be the control byte, ct%)  |
1590 rem + ------------------------------------------------------------------------ +
1592 rem | V0.01, pjw, 1995 Nov 26                                                  |
1594 rem | V0.02, pjw, 2015 Feb 26                                                  |
1596 rem | V0.02, pjw, 2024 Sep 27, This version has the flag built in              |
1598 rem + ------------------------------------------------------------------------ +
1600 :
1602 DEFine FuNction BTST%(btn%)
1604 RETurn (2 ^ btn% && ct%) <> 0
1606 END DEFine BTST%
1608 :
1610 rem + ------------------------------------------------------------------------ +
1612 rem |<                                 MkCtr$                                 >|
1614 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
1616 rem |                     Output control byte symbolically                     |
1618 rem + ------------------------------------------------------------------------ +
1620 rem | V0.01, pjw, 2024 Sep 27                                                  |
1622 rem + ------------------------------------------------------------------------ +
1624 :
1626 DEFine FuNction MkCtr$
1628 LOCal i%, cb$(8)
1630 cb$ = 'mpao0xcc'
1632 FOR i% = 0 TO 7
1634  IF BTST%(i%) = 0: cb$(8 - i%) = '-'
1636 END FOR i%
1638 RETurn cb$
1640 END DEFine MkCtr$
1642 :
1644 :
1646 rem + ------------------------------------------------------------------------ +
1648 rem |<                                Command Line                            >|
1650 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
1652 rem |                    Parses command line and sets defaults                 |
1654 rem |                                                                          |
1656 rem |  /F <filename>  - or /I - Input file name                                |
1658 rem |  /A address     - in hex. If given /F and /I ignored                     |
1660 rem |  /O <filename>  - Output file name (optional)                            |
1662 rem |  /S <nn>        - stack size (number of elements) (Optional, default 20) |
1664 rem |  /R             - Output suitable for assembly to SROFF (for linking)    |
1666 rem |  /G             - Output suitable for GWASS assembler                    |
1668 rem |                                                                          |
1670 rem | Dependencies: EXTRACT$, VALID%, DETAB$, (ODD)                            |
1672 rem | GLObal quote$                                                            |
1674 rem + ------------------------------------------------------------------------ +
1676 rem | V0.01, pjw, 2019 Jul 01, base version                                    |
1678 rem | V0.01, pjw, 2024 Sep 02, Spr2RLE version                                 |
1680 rem | V0.02, pjw, 2024 Sep 29, Added /R and /G; New Getent$ version            |
1682 rem | V0.03, pjw, 2024 Oct 05, Added /A option                                 |
1684 rem + ------------------------------------------------------------------------ +
1686 :
1688 def fn GetCmd(cl$)
1690 loc s%, e%, t$(48)
1692 :
1694 if cl$ = ' ': ret -15
1696 :
1698 rem     Defaults
1700 gwas   = 0:     rem Output for GWass
1702 relo   = 0:     rem Output for linking
1704 stkz%  = 0:     rem Stack size
1706 spa    = 0:     rem Object address
1708 :
1710 rem     Check for address
1712 t$ = Getent$("A")
1714 if len(t$) then
1716  er = ValidHex(t$, spa): if er < 0: ret er
1718  if ODD(spa) or spa = 0: ret -15
1720  :
1722  fno$ = Getent$("O")
1724  if len(fno$) = 0: fno$ = 'ram1_Sprite_asm'
1726 else
1728  rem     Get input file name
1730  fni$ = Getent$("F")
1732  if fni$ instr '': fni$ = Getent$("I")
1734  if fni$ instr '' then
1736   fni$ = cl$
1738   fno$ = 'ram1_sprite_asm'
1740  else
1742   fno$ = Getent$('O')
1744  endif
1746  :
1748  if fno$ instr '' then
1750   rem No output file name given, so use input as template
1752   fno$ = fni$(1 TO len(fni$) - 3) & 'asm'
1754  endif
1756 endif
1758 :
1760 s% = len(fno$)
1762 if s% < 6: ret -12
1764 if not fno$(s% - 3 to s%) == '_asm' then
1766  fno$ = fno$ & '_asm'
1768 endif
1770 :
1772 t$ = Getent$("S")
1774 if VALID%(3, t$): stkz% = t$
1776 if stkz% < 20: stkz% = 20
1778 :
1780 t$ = Getent$("R")
1782 if t$ = 'R': relo = 1
1784 :
1786 t$ = Getent$("G")
1788 if t$ = 'G': gwas = 1
1790 :
1792 ret 0
1794 enddef GetCmd
1796 :
1798 :
1800 rem + ------------------------------------------------------------------------ +
1802 rem |<                               Get Entry                                >|
1804 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
1806 rem |                       Given the key get the entry                        |
1808 rem |                                                                          |
1810 rem | Get a keyed parameter from command line                                  |
1812 rem |                                                                          |
1814 rem | Caller's cl$, s%, e%, t$. k$ is the key (no slash, eg P == /P)           |
1816 rem |                                                                          |
1818 rem | Syntax: < > = entity, { } = 1 or more, [ ] = 0 or 1, | = or              |
1820 rem |{ /K { [<space>] } < ["|'] <entry> ["|'] > | <blank> { <space> } } | <eol>|                                                                   |
1822 rem |                                                                          |
1824 rem | Returns:                                                                 |
1826 rem |          the parameter if found (with any quotes removed)                |
1828 rem |          the key itself for keys without parameter                       |
1830 rem |          null string if key not found                                    |
1832 rem |                                                                          |
1834 rem | Dependencies: tk EXTRACT$, DETAB$; quote$                                |
1836 rem + ------------------------------------------------------------------------ +
1838 rem | V0.01, pjw, 2019 Jul 01, base version                                    |
1840 rem | V0.02, pjw, 2024 Sep 29, complete rewrite                                |
1842 rem + ------------------------------------------------------------------------ +
1844 :
1846 DEFine FuNction Getent$(k$)
1848 s% = '/' & k$ instr cl$
1850 if s% = 0: ret ''
1852 e% = ' /' instr EXTRACT$(s% + 2, 999, cl$)
1854 if e% then
1856  e% = e% + s%
1858  t$ = DETAB$(EXTRACT$(s% + 2, e%, cl$))
1860 else
1862  t$ = DETAB$(EXTRACT$(s% + 2, 999, cl$))
1864 endif
1866 :
1868 rem         Strip trailing spaces
1870 for e% = len(t$) to 1 step -1
1872  if t$(e%) <> ' ': t$ = t$(1 to e%): exit e%
1874 endfor e%
1876 if t$ = ' ': return ''
1878 :
1880 if len(t$) > 1 then
1882  s% = t$(1) instr quote$
1884  if s% then
1886   if (t$(len(t$)) instr quote$) = s% then
1888    t$ = t$(2 to len(t$) - 1)
1890   endif
1892  endif
1894 else
1896  ret k$
1898 endif
1900 ret t$
1902 enddef Getent$
1904 :
1906 :
1908 rem + ------------------------------------------------------------------------ +
1910 rem |<                                ValidHex                                >|
1912 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
1914 rem |       Validate a hex string and return its decimal value or error        |
1916 rem |                                                                          |
1918 rem | Returns hex value in r.hx parameter!                                     |
1920 rem | A valid hex number is of the form                                        |
1922 rem |    [$]<hex digit>[<hex digit>] * 7                                       |
1924 rem | Where [] => optional, and hex digits are 0..9, A..F, a..f                |
1926 rem | The first non-hex charcter in an otherwise valid number terminates the   |
1928 rem | the number but does not invalidate it!                                   |
1930 rem | Numbers with more than 8 hex digits are truncated, but not invalidated!  |
1932 rem + ------------------------------------------------------------------------ +
1934 rem | V0.04, pjw, 2019 Dec 16, rewrite                                         |
1936 rem + ------------------------------------------------------------------------ +
1938 :
1940 DEFine FuNction ValidHex(hx$, r.hx)
1942 LOCal i%, d%, e%
1944 d% = (('$' INSTR hx$) = 1) + 1
1946 IF LEN(hx$) < d%: RETurn -15
1948 e% = d% + 7
1950 IF e% > LEN(hx$): e% = LEN(hx$)
1952 FOR i% = d% TO e%
1954  IF NOT hx$(i%) INSTR '0123456789ABCDEF': e% = i% - 1: EXIT i%
1956 END FOR i%
1958 IF e% < d%: RETurn -15
1960 r.hx = HEX(hx$(d% TO e%))
1962 RETurn 0
1964 END DEFine ValidHex
1966 :
1968 :
